import { DeleteWhere } from '../@types/commonType';



export const generateSQLDelete = (nameTable:string, {where, whereArrKey, condition}:DeleteWhere):{newSQLDelete: string} => {
  /*
    generateSQLDelete('Test', {whereArrKey: {name: ['Вася', "Петя"], age: [17,20]}})
    'DELETE FROM Test WHERE name = "Вася" OR name = "Петя", age = "17" OR age = "20"'
  */
  

  let defaultSqlStr = `DELETE FROM ${nameTable} WHERE`;

  if(whereArrKey && Object.keys(whereArrKey).length){
  
    let entries = Object.entries(whereArrKey);
    for(let [key, value] of entries){
      for(let i = 0; i < value.length; i++){
        defaultSqlStr += (` ${key} = "${value[i]}" ${condition ? condition : 'OR'}`)
      }
      defaultSqlStr = defaultSqlStr.replace(/(\sAND|\sOR)$/ig, ``);
      defaultSqlStr += ','
    }
    defaultSqlStr = defaultSqlStr.replace(/,$/ig, ``);


  }else if(where && Object.keys(where).length){
    
      for(let [key, value] of Object.entries(where)){
        defaultSqlStr += (` ${key}="${value}" ${condition ? condition : 'OR'}`)
      }
      defaultSqlStr = defaultSqlStr.replace(/(\sAND|\sOR)$/ig, ``);
      
  }else{
    console.dir('Не переданы из аргументов where | whereArrKey');
  }

    
  return {
    newSQLDelete: defaultSqlStr
  };
  
}